var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// index.ts
var ronin_exports = {};
__export(ronin_exports, {
  default: () => ronin_default,
  getQueriesFromScratchPad: () => getQueriesFromScratchPad,
  processReadables: () => processReadables,
  runQueries: () => runQueries2
});
module.exports = __toCommonJS(ronin_exports);

// utils/fetch.ts
var $fetch = async (url, init, fetcher = fetch) => fetcher(url, init).then((res) => res.json());
var fetch_default = $fetch;

// utils/helpers.ts
var combineKeys = (parent, child) => {
  const nested = child.replaceAll(".", "\\.");
  return parent ? `${parent}.${nested}` : nested;
};
var objectFromAccessor = (accessor, value) => setProperty({}, accessor, value);
var findSafeIndex = (map, index) => {
  const values = Array.from(map.values());
  const existing = values.find((item) => item[0] === index);
  if (existing) {
    return findSafeIndex(map, index + 1);
  }
  return index;
};
var setProperty = (object, path, value) => {
  const segments = path.split(/(?<!\\)[[.](?!\\)/g).filter((x) => !!x.trim()).map((x) => x.replaceAll("\\.", "."));
  const set = (node) => {
    if (segments.length > 1) {
      const key = segments.shift();
      node[key] = {};
      set(node[key]);
    } else {
      node[segments[0]] = value;
    }
  };
  set(object);
  return object;
};
var toDashCase = (string) => {
  const capitalize = (str) => {
    const lower = str.toLowerCase();
    return lower.substring(0, 1).toUpperCase() + lower.substring(1, lower.length);
  };
  const parts = string?.replace(/([A-Z])+/g, capitalize)?.split(/(?=[A-Z])|[.\-\s_]/).map((x) => x.toLowerCase()) ?? [];
  if (parts.length === 0)
    return "";
  if (parts.length === 1)
    return parts[0];
  return parts.reduce((acc, part) => `${acc}-${part.toLowerCase()}`);
};
var generateRandomID = () => {
  if (typeof crypto !== "undefined")
    return crypto.randomUUID();
  let dt = new Date().getTime();
  const uuid = "xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g, (char) => {
    const rand = (dt + Math.random() * 16) % 16 | 0;
    dt = Math.floor(dt / 16);
    return (char == "x" ? rand : rand & 3 | 8).toString(16);
  });
  return uuid;
};

// utils/scratchpads.ts
var extractReadables = (queries) => queries.reduce((references, query, queryIndex) => {
  return [
    ...references,
    ...Object.entries(query).reduce((references2, [queryType, query2]) => {
      if (!["set", "create"].includes(queryType))
        return references2;
      return [
        ...references2,
        ...Object.entries(query2).reduce((references3, [schema, instructions]) => {
          const fields = instructions[queryType === "set" ? "to" : "with"];
          return [
            ...references3,
            ...Object.entries(fields).reduce((references4, [name, value]) => {
              if (!(typeof File === "function" && value instanceof File) && !(value instanceof ReadableStream))
                return references4;
              return [
                ...references4,
                {
                  query: {
                    index: queryIndex,
                    type: queryType
                  },
                  schema,
                  field: name,
                  value,
                  contentType: typeof File === "function" && value instanceof File ? value.type : "application/octet-stream"
                }
              ];
            }, [])
          ];
        }, [])
      ];
    }, [])
  ];
}, []);
var getQueriesFromScratchPad = (scratchPad) => {
  const queries = [];
  const queriesWithoutSetters = /* @__PURE__ */ new Map();
  const getValidator = (queryType) => {
    const validator = {
      get(target, key) {
        const freshValidator = Object.assign({}, validator);
        freshValidator.id = this.id || generateRandomID();
        freshValidator.parentKey = combineKeys(this.parentKey, key);
        const queriesWithoutSettersIndex = findSafeIndex(queriesWithoutSetters, queries.length);
        queriesWithoutSetters.set(freshValidator.id, [
          queriesWithoutSettersIndex,
          {
            accessor: freshValidator.parentKey,
            queryType
          }
        ]);
        return new Proxy(target[key] || {}, freshValidator);
      },
      set(target, key, value) {
        const acessor = combineKeys(this.parentKey, key);
        const expanded = objectFromAccessor(acessor, value);
        queriesWithoutSetters.delete(this.id);
        if (["get", "set", "drop", "create", "count"].includes(queryType)) {
          queries.push({ [queryType]: expanded });
        }
        return true;
      }
    };
    return validator;
  };
  const getProxy = (type) => new Proxy({}, getValidator(type));
  scratchPad({
    get: getProxy("get"),
    set: getProxy("set"),
    drop: getProxy("drop"),
    create: getProxy("create"),
    count: getProxy("count")
  });
  for (const [index, details] of Array.from(queriesWithoutSetters.values())) {
    const { queryType, accessor } = details;
    queries.splice(index, 0, objectFromAccessor(`${queryType}.${accessor}`, null));
  }
  return queries;
};

// readables/index.ts
var storeReadables = async (readables, token, options = {}) => {
  const requests = readables.map(
    ({ value, contentType }, index) => fetch_default(
      options.endpoint || "https://data.ronin.co/writable",
      {
        method: options.method || "PUT",
        body: value,
        headers: { "Content-Type": contentType, Authorization: `Bearer ${token}` }
      },
      options?.fetcher
    ).then((reference) => ({
      ...readables[index],
      reference
    }))
  );
  return Promise.all(requests);
};
var processReadables = async (queries, token, options = {}) => {
  const readables = extractReadables(queries);
  if (readables.length > 0) {
    const storedReadables = await storeReadables(readables, token, options);
    for (const readable of storedReadables) {
      const { query, schema, field, reference } = readable;
      queries[query.index][query.type][schema][query.type === "set" ? "to" : "with"][field] = reference;
    }
  }
  return queries;
};

// queries/index.ts
var runQueries = async (queries, options = {}) => {
  if (typeof process !== "undefined") {
    options.token = options.token || process.env?.RONIN_TOKEN;
    if (!options.token) {
      let message = "Please specify the `RONIN_TOKEN` environment variable";
      message += " or set the `token` option when invoking RONIN.";
      throw new Error(message);
    }
  }
  if (!options.token) {
    let message = "When invoking RONIN from an edge runtime, the";
    message += " `token` option must be set.";
    throw new Error(message);
  }
  const queriesPopulatedWithReferences = await processReadables(
    queries,
    options.token,
    options.readableProcessingOptions
  );
  const url = new URL(options.queryProcessingOptions?.endpoint || "https://data.ronin.co");
  const customDatabase = options.queryProcessingOptions?.database;
  if (customDatabase) {
    url.searchParams.set("custom_database", customDatabase);
  }
  const { results, error } = await fetch_default(
    url.href,
    {
      method: "POST",
      headers: {
        "Content-Type": "application/json",
        Authorization: `Bearer ${options.token}`
      },
      body: JSON.stringify({
        queries: queriesPopulatedWithReferences
      })
    },
    options?.queryProcessingOptions?.fetcher
  );
  if (error) {
    throw new Error(error.message);
  }
  return results.map((result) => {
    if (result.error) {
      throw new Error(result.error.message);
    }
    if (typeof result.record !== "undefined")
      return result.record;
    if (typeof result.amount !== "undefined")
      return result.amount;
    if (result.moreAfter) {
      result.records.moreAfter = result.moreAfter;
    }
    return result.records;
  });
};

// utils/data-hooks.ts
var EMPTY = Symbol("empty");
var getSchema = (instruction) => {
  const key = Object.keys(instruction)[0];
  let schema = String(key);
  let multipleRecords = false;
  if (schema.endsWith("s")) {
    schema = schema.substring(0, schema.length - 1);
    multipleRecords = true;
  }
  return {
    key,
    schema: toDashCase(schema),
    multipleRecords
  };
};
var getMethodName = (hookType, queryType) => {
  const capitalizedQueryType = queryType[0].toUpperCase() + queryType.slice(1);
  return hookType === "during" ? queryType : hookType + capitalizedQueryType;
};
var invokeHook = async (hooks, hookType, query) => {
  const hooksForSchema = hooks?.[query.schema];
  const hookName = getMethodName(hookType, query.type);
  const queryInstruction = query.instruction ? structuredClone(query.instruction) : {};
  const hookArguments = [queryInstruction, query.plural];
  if (hookType === "after") {
    const queryResult = structuredClone(query.result);
    hookArguments.push(queryResult);
  }
  if (hooksForSchema?.[hookName]) {
    const result = await hooksForSchema[hookName](...hookArguments);
    return { ran: true, result };
  }
  return { ran: false, result: null };
};
var invokeHooks = async (hooks, hookType, modifiableQueries, modifiableResults, query) => {
  const queryType = Object.keys(query.definition)[0];
  const queryInstructions = query.definition[queryType];
  const { key, schema, multipleRecords } = getSchema(queryInstructions);
  const oldInstruction = queryInstructions[key];
  const executedHookResults = await invokeHook(hooks, hookType, {
    type: queryType,
    schema,
    plural: multipleRecords,
    instruction: oldInstruction,
    result: hookType === "after" ? query.result : null
  });
  const { ran, result: hookResult } = executedHookResults;
  switch (hookType) {
    case "before":
      if (!ran)
        break;
      queryInstructions[key] = hookResult;
      modifiableQueries[query.index] = { [queryType]: queryInstructions };
      break;
    case "during":
      if (ran) {
        modifiableQueries[query.index] = EMPTY;
        modifiableResults[query.index] = hookResult;
      } else {
        modifiableResults[query.index] = EMPTY;
      }
      break;
    case "after":
      break;
  }
};
var runQueriesWithHooks = async (queries, options) => {
  let modifiableQueries = Array.from(queries);
  const modifiableResults = [];
  const { hooks } = options || {};
  await Promise.all(
    queries.map((query, index) => {
      return invokeHooks(hooks, "before", modifiableQueries, modifiableResults, {
        definition: query,
        index,
        result: null
      });
    })
  );
  await Promise.all(
    queries.map((query, index) => {
      return invokeHooks(hooks, "during", modifiableQueries, modifiableResults, {
        definition: query,
        index,
        result: null
      });
    })
  );
  modifiableQueries = modifiableQueries.filter((query) => query !== EMPTY);
  if (modifiableQueries.length === 0)
    return modifiableResults;
  const results = await runQueries(modifiableQueries, options);
  for (let index = 0; index < modifiableResults.length; index++) {
    const existingResult = modifiableResults[index];
    if (existingResult === EMPTY) {
      continue;
    }
    results.splice(index, 0, existingResult);
  }
  for (let queryIndex = 0; queryIndex < queries.length; queryIndex++) {
    const query = queries[queryIndex];
    const queryType = Object.keys(query)[0];
    if (queryType !== "set" && queryType !== "drop" && queryType !== "create") {
      continue;
    }
    const queryResult = results[queryIndex];
    invokeHooks(hooks, "after", queries, null, {
      definition: query,
      index: queryIndex,
      result: queryResult
    });
  }
  return results;
};

// index.ts
var runScratchpad = async (scratchPad, options) => {
  const queries = getQueriesFromScratchPad(scratchPad);
  if (queries.length === 0)
    return [];
  return runQueriesWithHooks(queries, options);
};
var runQueries2 = runQueriesWithHooks;
var createScratchpadFactory = (config) => {
  return (scratchPad) => runScratchpad(scratchPad, config);
};
function handleScratchPadOrConfig(input, config) {
  if (typeof input === "function") {
    return runScratchpad(input, config);
  }
  if (typeof input === "undefined" || typeof input === "object" && !Array.isArray(input) && input !== null) {
    return createScratchpadFactory(input);
  }
  let message = 'The function exported by the "ronin" package must receive either';
  message += " a scratchpad (function) or an initial configuration (object).";
  throw new Error(message);
}
var ronin_default = handleScratchPadOrConfig;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getQueriesFromScratchPad,
  processReadables,
  runQueries
});
